---
title: USBAlternateInterface
slug: Web/API/USBAlternateInterface
tags:
  - API
  - Experimental
  - Interface
  - NeedsExample
  - Reference
  - USBAlternateInterface
  - WebUSB
  - WebUSB API
---
<p>{{draft}}{{securecontext_header}}{{APIRef("WebUSB API")}}</p>

<p>The <code>USBAlternateInterface</code> interface of the <a href="/en-US/docs/Web/API/WebUSB_API" rel="nofollow">WebUSB API</a> provides information about a particular configuration of an interface provided by the USB device. An interface includes one or more alternate settings which can configure a set of endpoints based on the operating mode of the device.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("USBAlternateInterface.USBAlternateInterface")}}</dt>
 <dd>Creates a new <code>USBAlternateInterface</code> object which will be populated with information about the alternate interface of the provided <code>USBInterface</code> with the given alternate setting number.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("USBAlternateInterface.alternateSetting")}}{{readonlyInline}}</dt>
 <dd>Returns the alternate setting number of this interface. This is equal to the <code>bAlternateSetting</code> field of the interface descriptor defining this interface.</dd>
 <dt>{{domxref("USBAlternateInterface.interfaceClass")}}{{readonlyInline}}</dt>
 <dd>Returns the class of this interface. This is equal to the <code>bInterfaceClass</code> field of the interface descriptor defining this interface. <a href="https://www.usb.org/defined-class-codes">Standardized values</a> for this field are defined by the USB Implementers Forum. A value of <code>0xFF</code> indicates a vendor-defined interface.</dd>
 <dt>{{domxref("USBAlternateInterface.interfaceSubclass")}}{{readonlyInline}}</dt>
 <dd>Returns the subclass of this interface. This is equal to the <code>bInterfaceSubClass</code> field of the interface descriptor defining this interface. The meaning of this value depends on the <code>interfaceClass</code> field.</dd>
 <dt>{{domxref("USBAlternateInterface.interfaceProtocol")}}{{readonlyInline}}</dt>
 <dd>Returns the protocol supported by this interface. This is equal to the <code>bInterfaceProtocol</code> field of the interface descriptor defining this interface. The meaning of this value depends on the <code>interfaceClass</code> and <code>interfaceSubclass</code> fields.</dd>
 <dt>{{domxref("USBAlternateInterface.interfaceName")}}{{readonlyInline}}</dt>
 <dd>Returns the name of the interface, if one is provided by the device. This is the value of the string descriptor with the index specified by the <code>iInterface</code> field of the interface descriptor defining this interface.</dd>
 <dt>{{domxref("USBAlternateInterface.endpoints")}}{{readonlyInline}}</dt>
 <dd>Returns an array containing instances of the <code>USBEndpoint</code> interface describing each of the endpoints that are part of this interface.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web USB','#usbalternateinterface','USBAlternateInterface')}}</td>
   <td>{{Spec2('Web USB')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.USBAlternateInterface")}}</p>
